<?php

/*
Plugin Name: NoFollow Free
Plugin URI: http://www.michelem.org/wordpress-plugin-nofollow-free/
Description: Remove the nofollow tag from your blog's comments and display a top image band to tell it to your users (optionally)
Version: 1.0
Author: Michele Marcucci
Author URI: http://www.michelem.org/

Copyright (c) 2007 Michele Marcucci
Released under the GNU General Public License (GPL)
http://www.gnu.org/licenses/gpl.txt
*/

$siteurl =  get_option('siteurl');
$defaultdata = array(
	'nofollow_author' => "yes",
	'nofollow_text' => "no",
	'display_band' => "yes",
	'position_band' => "right",
	'colour_band' => "red",
	'url_band' =>  "http://www.michelem.org/wordpress-plugin-nofollow-free/",
	'nofollow_limit' => "10",
	'count_comments' => "no",
	'comment_link' => "yes"
	);

add_filter('get_comment_author_link', 'remove_nofollow_author', 11);
add_filter('comment_text', 'remove_nofollow_text');
add_action('loop_end', 'addnofflink');

function addnofflink($text='') {
global $noff_settings, $single, $feed, $post;
        if(!$feed && $single ){
                if($noff_settings['comment_link'] == "yes") {
                        echo("<br>Comments links could be <a href='http://www.michelem.org/wordpress-plugin-nofollow-free/'>nofollow free</a>.");}
        }
        return $text;
}

function remove_nofollow_author($nofollow) {
global $noff_settings, $wpdb, $comment;
	if ($noff_settings['blacklist'] != '') {
		$words = explode(',', $noff_settings['blacklist']);
		foreach ($words as $word) {
			if (eregi($word, $comment->comment_content) || eregi($word, $comment->comment_author)) {
				$block = 1;
			}
		}
	}
	$queryString="select count(1) as comments from $wpdb->comments where `comment_author_email` = '$comment->comment_author_email'";
	$comments_count = $wpdb->get_var($queryString);
	if ($noff_settings['count_comments'] == 'yes') {
		if ($comment->comment_type != "pingback" && $comment->comment_type != "trackback") {
			$nofollow .= " (".$comments_count." comments)";
		}
	}
	if ($noff_settings['nofollow_author'] == 'yes' && $block != 1) {
		if ($comments_count >= $noff_settings['nofollow_limit'] || $noff_settings['nofollow_limit'] == 0) {
			$nofollow = preg_replace("/rel='external nofollow'>/","rel='external'>", $nofollow);
			return $nofollow;
		} else {
			return $nofollow;
		}
	} else {
		return $nofollow;
	}
}

function remove_nofollow_text($nofollow = '') {
global $noff_settings, $wpdb, $comment;
	if ($noff_settings['blacklist'] != '') {
		$words = explode(',', $noff_settings['blacklist']);
		foreach ($words as $word) {
			if (eregi($word, $comment->comment_content)) {
				$block_text = 1;
			}
		}
	}
	$queryString="select count(1) as comments from $wpdb->comments where `comment_author_email` = '$comment->comment_author_email'";
	$comments_count = $wpdb->get_var($queryString);
	if ($noff_settings['nofollow_text'] == 'yes' && $block_text != 1) {
		if ($comments_count >= $noff_settings['nofollow_limit'] || $noff_settings['nofollow_limit'] == 0) {
			$nofollow = preg_replace("/(<a[^>]*[^\s])(\s*nofollow\s*)/i", "$1", $nofollow);
			$nofollow = preg_replace("/(<a[^>]*[^\s])(\s*rel=\"\s*\")/i", "$1", $nofollow);
			$pattern='/" rel="nofollow">/';
			$replacement='" >';
			$nofollow = preg_replace($pattern, $replacement,$nofollow);
			return $nofollow;
		} else {
			return $nofollow;
		}
	} else {
		return $nofollow;
	}
}

function noff() {
global $noff_settings;
	if (!is_feed() && !is_admin()) {
		$siteurl =  get_option('siteurl');
		if ($noff_settings['display_band'] == 'yes') {
			$url_band = $noff_settings['url_band'];
			$position = $noff_settings['position_band'];
			$colour = $noff_settings['colour_band'];
			if ($noff_settings['position_band'] == 'left') {
				$noff = '
				<style type="text/css">
				.csscontestbadge {
				position: absolute;
				top: 0;
				left: 0;
				background: transparent url("'.$siteurl.'/wp-content/plugins/noff/images/css_nofollow_badge'.$colour.$position.'.gif") no-repeat top left;
				height: 129px;
				width: 129px; }
		
				.csscontestbadge a {
				display: block;
				width: 129px;
				height: 129px;
				text-decoration: none !important;
				background: transparent !important; }
				</style>
				<div class="csscontestbadge"><a href="'.$url_band.'" title="This blog is NOFOLLOW Free!">&nbsp;</a></div>';
			} else {
				$noff = '
				<style type="text/css">
				.csscontestbadge {
				position: absolute;
				top: 0;
				right: 0;
				background: transparent url("'.$siteurl.'/wp-content/plugins/noff/images/css_nofollow_badge'.$colour.$position.'.gif") no-repeat top left;
				height: 129px;
				width: 129px; }
		
				.csscontestbadge a {
				display: block;
				width: 129px;
				height: 129px;
				text-decoration: none !important; }
				</style>
				<div class="csscontestbadge"><a href="'.$url_band.'" title="This blog is NOFOLLOW Free!">&nbsp;</a></div>';
			}

		print $noff."\n";
		}
        }
}

//add_action('get_footer', 'noff');

add_option('noff_settings', $defaultdata, 'Options for NoFollowFree');

$noff_settings = get_option('noff_settings');

add_action('admin_menu', 'add_noff_options_page');

function add_noff_options_page()
{
	if (function_exists('add_options_page'))
	{
		add_options_page('NoFollowFree', 'NOFF', 8, basename(__FILE__), 'noff_options_subpanel');
	}
}

function noff_options_subpanel()
{
	global $noff_settings, $_POST;
	
	if (isset($_POST['submit']))
	{
		$noff_settings['nofollow_author'] = $_POST['nofollow_author'];
		$noff_settings['nofollow_text'] = $_POST['nofollow_text'];
		$noff_settings['display_band'] = $_POST['display_band'];
		$noff_settings['position_band'] = $_POST['position_band'];
		$noff_settings['colour_band'] = $_POST['colour_band'];
		$noff_settings['url_band'] = $_POST['url_band'];
		$noff_settings['nofollow_limit'] = $_POST['nofollow_limit'];
		$noff_settings['count_comments'] = $_POST['count_comments'];
		$noff_settings['blacklist'] = $_POST['blacklist'];
		$noff_settings['comment_link'] = $_POST['comment_link'];
		
		update_option('noff_settings', $noff_settings);
	}

	?>
	<div class="wrap">
        <h2>NoFollow Free</h2>
        <form action="" method="post">
	<p>Select if you want to remove "nofollow" attribute from comment author and/or comment body text link</p>
        <h3>Do you want to remove nofollow from comment <strong>author</strong> link? (default YES)</h3>
        <p><input type="radio" name="nofollow_author" value="yes" <?php if ($noff_settings['nofollow_author'] == 'yes') echo 'checked="checked"'; ?> /> YES</p>
        <p><input type="radio" name="nofollow_author" value="no" <?php if ($noff_settings['nofollow_author'] == 'no') echo 'checked="checked"'; ?> /> NO</p>
        <h3>Do you want to remove nofollow from comment <strong>text</strong> link? (default NO)</h3>
        <p><input type="radio" name="nofollow_text" value="yes" <?php if ($noff_settings['nofollow_text'] == 'yes') echo 'checked="checked"'; ?> /> YES</p>
        <p><input type="radio" name="nofollow_text" value="no" <?php if ($noff_settings['nofollow_text'] == 'no') echo 'checked="checked"'; ?> /> NO</p>
        <h3>Set how many comments the author must have written before I remove the nofollow. (default 10)</h3>
	<p>Set <strong>0</strong> to always remove the nofollow. <input type="text" name="nofollow_limit" size="3" value="<?php echo $noff_settings['nofollow_limit'] ?>" /></p>
        <h3>Do you want number of comments by a particular author displayed after their name? (default NO)</h3>
        <p><input type="radio" name="count_comments" value="yes" <?php if ($noff_settings['count_comments'] == 'yes') echo 'checked="checked"'; ?> /> YES</p>
        <p><input type="radio" name="count_comments" value="no" <?php if ($noff_settings['count_comments'] == 'no') echo 'checked="checked"'; ?> /> NO</p>
        <h3>Here you can set some <strong>comma</strong> separated words. If one or more of these words are found in the text comment I put back the nofollow, just to prevent spammers.</h3>
	<textarea rows="4" cols="80" name="blacklist"><?php echo htmlentities($noff_settings['blacklist']); ?></textarea>
        <h3>Do you want to donate a link to this plugin? (default YES)</h3>
        <p><input type="radio" name="comment_link" value="yes" <?php if ($noff_settings['comment_link'] == 'yes') echo 'checked="checked"'; ?> /> YES</p>
        <p><input type="radio" name="comment_link" value="no" <?php if ($noff_settings['comment_link'] == 'no') echo 'checked="checked"'; ?> /> NO, I will write a post about this plugin :)<p>

	<hr>
	<p>In order to display the top band remember to insert the <strong>&lt;?php noff() ?&gt;</strong> function into your template just after the &lt;body&gt; attribute like this:</p>
	<blockquote>
	<p>&lt;body&gt;<br>
	<strong>&lt;?php noff() ?&gt;</strong><br>
	...
	</p>
	</blockquote>
	<p>This action is required ONLY IF you want to display the top band, the nofollow attribute from your comments are just disappeared. (If you haven't changed it above)</p>
        <h3>Do you want the CSS image band at the top of the page?</h3>
        <p><input type="radio" name="display_band" value="yes" <?php if ($noff_settings['display_band'] == 'yes') echo 'checked="checked"'; ?> /> YES</p>
        <p><input type="radio" name="display_band" value="no" <?php if ($noff_settings['display_band'] == 'no') echo 'checked="checked"'; ?> /> NO</p>
	<?php if ($noff_settings['display_band'] == 'yes') { 
		if ($noff_settings['position_band'] == '') {
			$noff_settings['position_band'] = 'right';
		}
		if ($noff_settings['colour_band'] == '') {
			$noff_settings['colour_band'] = 'green';
		}
	?>
        <h3>Which position do you prefer?</h3>
        <p><input type="radio" name="position_band" value="right" <?php if ($noff_settings['position_band'] == 'right') echo 'checked="checked"'; ?> /> Right</p>
        <p><input type="radio" name="position_band" value="left" <?php if ($noff_settings['position_band'] == 'left') echo 'checked="checked"'; ?> /> Left</p>
        <h3>Which band colour do you prefer?</h3>
        <p><input type="radio" name="colour_band" value="green" <?php if ($noff_settings['colour_band'] == 'green') echo 'checked="checked"'; ?> /> Green</p>
        <p><input type="radio" name="colour_band" value="red" <?php if ($noff_settings['colour_band'] == 'red') echo 'checked="checked"'; ?> /> Red</p>
        <p><input type="radio" name="colour_band" value="orange" <?php if ($noff_settings['colour_band'] == 'orange') echo 'checked="checked"'; ?> /> orange</p>
        <p><input type="radio" name="colour_band" value="blue" <?php if ($noff_settings['colour_band'] == 'blue') echo 'checked="checked"'; ?> /> Blue</p>
        <h3>What url do you want when someone click the band?</h3>
        <p><input type="text" name="url_band" size="60" value="<?php echo $noff_settings['url_band'] ?>" /></p>
	<?php } ?>
        <p><input type="submit" name="submit" value="Save Settings" /></p>
        </form>
	<hr>
	<p>Check if your <a href="http://www.michelem.org/wordpress-plugin-nofollow-free/"><strong>nofollow-free plugin</strong></a> is updated</p>
        </div>
	<?php
}


?>
